var NwT = {
    init:function (loginStatus) {
        try {
            NwT.popupWindow = null;
            NwT.connectUrls = {"fb":"", "linkedin":""};
            NwT.clientIds = {"fb":"", "linkedin":""};
            NwT.fbUrl = "https://" + location.hostname + "/fbauth";
            NwT.connectUrls.linkedin = "https://" + location.hostname + "/oauthcall?req=authorize&type=3&mode=dlg";
            NwT.connectUrls.twitter = "https://" + location.hostname + "/oauthcall?req=authorize&type=4&mode=dlg";
            NwT.clientIds.fb = $("#fbClientId").val();
            NwT.connectUrls.fb = "https://www.facebook.com/dialog/oauth?client_id=" + NwT.clientIds.fb +
                "&display=popup&scope=email,user_education_history,user_work_history,friends_education_history,friends_work_history,publish_actions&redirect_uri=" + encodeURIComponent(NwT.fbUrl);

            if(loginStatus=="0"){
                CwAuth.hideAndShowSection("login");
                $(".alert-msg").show();
            }
        } catch (ex) {

        }
    },
    showPopUp:function () {
        var url = "", el = $(this), height = 240, width = 320, leftPosition, topPosition;
        leftPosition = (window.screen.width / 2) - ((width / 2) + 10);
        topPosition = (window.screen.height / 2) - ((height / 2) + 50);
        if (NwT.popupWindow && NwT.popupWindow.close)
            NwT.popupWindow.close();
        if (el.hasClass("btn-facebook") || el.hasClass("fbLogin")) {
            url = NwT.connectUrls.fb;
        } else if (el.hasClass("btn-linkedin")) {
            url = NwT.connectUrls.linkedin;
        } else if (el.hasClass("btn-twitter")) {
            url = NwT.connectUrls.twitter;
        }
        else {
            url = window.location.href;
        }
        NwT.popupWindow = window.open(url, "_blank", "height=" + height + ",width=" + width +
            "left=" + leftPosition + ",top=" + topPosition + ",screenX=" + leftPosition + ",screenY=" + topPosition +
            "directories=no,location=no,menubar=no,resizable=no,scrollbars=no,status=no,toolbar=no");
    },
    doAction:function (params, wind) {
        try {
            NwT.popupWindow = wind;
            $(".submitform").removeClass("submitform");
            $("input[type='password']").val("");
            var connect = "facebook";
            var action = "error";
            if (params) {
                if (params["connection"]) {
                    connect = params["connection"];
                }
                if (params["action"]) {
                    action = params["action"];
                }
            }
            if (NwT.popupWindow)
                NwT.popupWindow.close();
            if (connect == "facebook") {
                NwT.etype = 2;
                var fbSignup = $(".fb-signup");
                var firstName = "", lastName = "", email = "", openid = "", imgUrl = "", token = "", name = "",
                    username = "", uid = "", fbError = "";
                firstName = CwValidate.checkEmpty(params["extFirstName"]);
                lastName = CwValidate.checkEmpty(params["extLastName"]);
                email = CwValidate.checkEmpty(params["extEmail"]);
                openid = CwValidate.checkEmpty(params["extOpenId"]);
                imgUrl = "https://graph.facebook.com/" + openid + "/picture?width=82&height=82&ts=" + (new Date().getTime());
                token = CwValidate.checkEmpty(params["extToken"]);
                name = CwValidate.checkEmpty(params["extName"]);
                username = CwValidate.checkEmpty(params["extUserName"]);
                uid = CwValidate.checkEmpty(params["extUId"]);
                fbError = CwValidate.checkEmpty(params["msg"]);

                fbSignup.find(".extFirstName").val(firstName);
                fbSignup.find(".extLastName").val(lastName);
                fbSignup.find(".extEmail").val(email);
                fbSignup.find(".extOpenId").val(openid);
                fbSignup.find(".extToken").val(token);
                fbSignup.find(".extName").val(name);
                fbSignup.find(".extUserName").val(username);
                fbSignup.find(".extUserImg").attr("src", imgUrl);
                fbSignup.find(".extImgUrl").val(imgUrl);
                fbSignup.find(".extUId").val(uid);
                fbSignup.find("#fbEmailExists").text(email);
                switch (action) {
                    case "close":
                        try {
                            NwT.popupWindow.close();
                        } catch (ex) {
                            NwT.log(ex);
                        }
                        break
                    case "create":
                        CwAuth.hideAndShowSection("fb-create", function () {
                            fbSignup.find(".form").hide();
                            fbSignup.find("#fb-create-checkme2").attr("checked", "checked");
                            fbSignup.find(".cw-dont-have-colwiz-account-form").show();
                        });
                        break;
                    case "connect":
                        CwAuth.hideAndShowSection("fb-connect", function () {
                            fbSignup.find(".form").hide();
                            fbSignup.find("#fb-already-exists-checkme1").attr("checked", "checked");
                            fbSignup.find(".cw-connect-with-same-account-form").show();
                        });
                        break;
                    case "login":
                        CwAuth.hideAndShowSection();
                        window.parent.postMessage("hideLoginFrame", "*"); // fb login
                        window.location = window.location.protocol + "//" + window.location.hostname + "/cwauth";
                        break;
                    default:
                        if (fbError.length == 0) {
                            fbError = "An error occured while connecting with " + CwAuth.getProvider() + ". Please try again later.";
                        }
                        $(".alert-msg").show().removeClass("success-msg").addClass("error-msg").find("span").text(fbError);
                        break;
                }
            }
            else if (connect.toLowerCase() == "linkedin") {
                NwT.etype = 3;
                var extLogin = $(".ext-signup"), provider = "Linkedin";
                var extFirstName = "", extLastName = "", extEmail = "", extOpenId = "", extImgUrl = "", extToken = "", extName = "",
                    extUserName = "", extUId = "", extType = "", extAction = "", extError = "";
                extFirstName = CwValidate.checkEmpty(params["extFirstName"]);
                extLastName = CwValidate.checkEmpty(params["extLastName"]);
                extEmail = CwValidate.checkEmpty(params["extEmail"]);
                extOpenId = CwValidate.checkEmpty(params["extOpenId"]);
                extImgUrl = CwValidate.checkEmpty(params["extImgUrl"]);
                extToken = CwValidate.checkEmpty(params["extToken"]);
                extName = CwValidate.checkEmpty(params["extName"]);
                extUserName = CwValidate.checkEmpty(params["extUserName"]);
                extUId = CwValidate.checkEmpty(params["extUId"]);
                extType = CwValidate.checkEmpty(params["extType"]);
                extError = CwValidate.checkEmpty(params["msg"]);


                extLogin.find(".extAction,.extContext").val(action);
                extLogin.find(".extFirstName").val(extFirstName);
                extLogin.find(".extLastName").val(extLastName);
                extLogin.find(".extEmail").val(extEmail);
                extLogin.find(".extOpenId").val(extOpenId);
                extLogin.find(".extToken").val(extToken);
                extLogin.find(".extName").val(extName);
                extLogin.find(".extUserImg").attr("src", extImgUrl);
                extLogin.find(".extImgUrl").val(extImgUrl);
                extLogin.find(".extType").val(extType);
                extLogin.find("#lkEmailExists").text(extEmail);
                if (extUId.length == 0)
                    extUId = "-1";
                extLogin.find(".extUId").val(extUId);
                if (extType == "3") {
                    provider = "LinkedIn";
                } else if (extType == "4") {
                    provider = "Twitter";
                }
                extLogin.find(".provider").html(provider);
                switch (action) {
                    case "close":
                        try {
                            NwT.popupWindow.close();
                        } catch (ex) {
                            NwT.log(ex);
                        }
                        break
                    case "create":
                        CwAuth.hideAndShowSection("lk-create", function () {
                            extLogin.find(".form").hide();
                            extLogin.find("#lk-create-checkme2").attr("checked", "checked");
                            extLogin.find(".cw-dont-have-colwiz-account-form").show();
                        });
                        break;
                    case "connect":
                        CwAuth.hideAndShowSection("lk-connect", function () {
                            extLogin.find(".form").hide();
                            extLogin.find("#lk-already-exists-checkme1").attr("checked", "checked");
                            extLogin.find(".cw-connect-with-same-account-form").show();
                        });
                        break;
                    case "ok":
                    case "login":
                        CwAuth.hideAndShowSection();
                        window.parent.postMessage("hideLoginFrame", "*");  // linkedin login
                        break;
                    default:
                        if (extError.length == 0) {
                            extError = "An error occured while connecting with " + CwAuth.getProvider() + ". Please try again later.";
                        }
                        $(".alert-msg").show().removeClass("success-msg").addClass("error-msg").find("span").text(extError);
                        break;

                }
            }
        } catch (ex) {
            NwT.log(ex);
        }
    },
    getProvider:function () {
        var str = "Facebook";
        switch (NwT.etype) {
            case 2:
                str = "Facebook";
                break;
            case 3:
                str = "LinkedIn";
                break;
            default :
                str = "Facebook";
        }
        return str;
    },
    log:function (ex) {
        if (CwAuth.debug) {
            if ($.browser.msie) {
                alert(ex);
            } else {
                console.info(ex);
            }
        }
    }
};
var CwAuth = {
    init:function () {
        CwAuth.debug = true;
        var location = $(document.location).attr('href'), loginStatus = CwAuth.getQueryParam("success", location);
        if (loginStatus == ""){
            loginStatus = (CwAuth.getQueryParam("email", location) == "0" || CwAuth.getQueryParam("pass", location) == "0" || CwAuth.getQueryParam("active", location) == "0")?"0":"";
        }
        if (window.parent) {
            switch (loginStatus) {
                case "0":
                    window.parent.postMessage("loginFailed", "*");     //login Failed
                    break;
                case "1":
                    window.parent.postMessage("signupSuccess", "*");     //signup
                    break;
                case "2":
                    window.parent.postMessage("hideLoginFrame", "*");    //login
                    break;
            }
            CwAuth.registerEvents();
            NwT.init(loginStatus);
        } else {
            window.parent.postMessage("closeLoginFrame", "*");
        }
    },
    logAnalytics:function (url) {
        try {
            if (_gaq) {
                _gaq.push(['_trackPageview', url]);
            }
        } catch (ex) {
            NwT.log("Page Ajax logAnalytics");
            NwT.log(ex);
        }
    },
    registerEvents:function () {
        $(".signup-btn").off("click").on("click", {mode:"signup"}, CwAuth.showSignup);
        $(".signin-btn").off("click").on("click", {mode:"login"}, CwAuth.showSignup);
        $("form").off("submit").on("submit", {mode:"container"}, CwValidate.validateData);
        $("[data-validation]").off("blur").on("blur", {mode:"item"}, CwAuth.onBlur);
        $(".auth-btn").on("click", function () {
            var action = $(this).data("action");
            switch (action) {
                case "signup":
                    $("#signin").hide();
                    $("#signup").show();
                    break;
                case "login":
                    $("#signin").show();
                    $("#signup").hide();
                    break;
                default:
                    $(".signup-btn").click();
                    window.parent.postMessage("closeLoginFrame", "*");
                    window.location = window.location.protocol + "//" + window.location.hostname + "/cwauth";
                    break;
            }
        });
        $("input[type='radio']").off("click").on("click", CwAuth.switchForms);
        $(".extlogin").off("click").on("click", NwT.showPopUp);
    },
    switchForms:function (evt) {
        var el = $(this), mode = el.data("mode");
        $(".form").hide();
        $(".cw-" + mode + "-form").show();
        if (NwT.etype == 3) {
            el.parents(".section").first().find(".extAction").val(el.data("context"));
        }
    },
    trim:function (str) {
        try {
            var newStr = "";
            if (str && str != null && str.length > 0)
                newStr = str;
            newStr = newStr.replace(/^[\xA0\s]+/, '').replace(/[\xA0\s]+$/, '');
        } catch (ex) {
            NwT.log(ex);
        }
        return newStr;

    },
    onBlur:function (evt) {
        if ($(this).hasClass("invalid")) {
            CwValidate.validateData(evt);
        }
    },
    showSignup:function (evt) {
        CwAuth.hideAndShowSection(evt.data.mode);
    },
    hideAndShowSection:function (mode, promise) {
        if (promise == undefined) promise = function () {
        };
        $("input.invalid").removeClass(".invalid");
        $(".alert-msg").hide();
        $(".section.open").fadeOut("fast", function () {
            $(this).removeClass("open");
            if (mode) $("." + mode + "-section").fadeIn(promise).addClass("open");
        });
    },
    getQueryParam:function (name, url) {
        if (url == undefined) {
            url = location.search;
        }
        name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
        var regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
        var results = regex.exec(url);
        return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
    }
};
var CwValidate = {
    checkEmpty:function (vl) {
        var val = "";
        try {
            val = (vl ? vl : "");
        }
        catch (e) {
            val = "";
        }
        return val;
    },
    validateData:function (evt) {
        var container = $(evt.target);
        var mode = evt.data.mode, submit = true;
        var validationItems = $("[data-validation]");
        if (mode == "container") {
            validationItems = $(container).find("[data-validation]:not(:hidden)");
        } else if (mode == "item") {
            validationItems = $(container);
        }

        for (var k = 0; (k < validationItems.length) && submit; k++) {
            var elem = $(validationItems[k]);
            var validate = elem.data("validation").split(" ");
            var value = CwAuth.trim(elem.val());
            for (var i = 0; i < validate.length; i++) {
                var validateError = validate[i];
                var action = validateError.split(":");
                if (action[0] == "required") {
                    if (CwValidate.isEmpty(value)) {
                        elem.addClass("invalid");
                        elem.data("error", "Please enter " + elem.attr("placeholder"));
                        break;
                    } else {
                        elem.removeClass("invalid");
                    }
                } else {
                    switch (action[0]) {
                        case "min-length":
                            if (!CwValidate.hasMinLength(value, action[1])) {
                                elem.addClass("invalid");
                                elem.data("error", "Please write at least " + action[1] + " characters");
                            } else {
                                elem.removeClass("invalid");
                            }
                            break;
                        case "max-length":
                            if (!CwValidate.hasMaxLength(value, action[1])) {
                                elem.data("error", "Maximum characters limit is " + action[1]);
                                elem.addClass("invalid");
                            } else {
                                elem.removeClass("invalid");
                            }
                            break;
                        case "email":
                            if (!((CwValidate.isEmpty(value)) || (CwValidate.isEmail(value)))) {
                                elem.data("error", "Please Enter Valid Email Address");
                                elem.addClass("invalid");
                            } else {
                                elem.removeClass("invalid");
                            }
                            break;
                    }
                }
            }

            if (elem.hasClass("invalid")) {
                submit = false;
                $(".alert-msg").show().removeClass("success-msg").addClass("error-msg").find("span").html(elem.data("error"));

            } else {
                $(".alert-msg").hide();
            }
        }
        if (validationItems.is(".invalid") && mode == "container") {
            evt.preventDefault();
        }
        return true;
    },
    isEmpty:function (val) {
        return (val.length == 0);
    },
    isEmail:function (email) {
        var reg = /^([a-zA-Z0-9_\-\.\+]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/
        return reg.test(email);
    },
    hasMinLength:function (text, length) {
        if (text && text.length < length) {
            return false;
        }
        else {
            return true;
        }
    },
    hasMaxLength:function (text, length) {
        if (text && text.length > length) {
            return false;
        }
        else {
            return true;
        }
    }
};
$(document).ready(CwAuth.init);
window.addEventListener("message", function (evt) {
    var message=evt.data.message,url=evt.data.url;
    switch (message) {
		case "sendShowLogin":
			$(".signin-btn").trigger("click");
			break;
        case "logAnalyticsa":
            CwAuth.logAnalytics(url);
            break;
        case "setService":
            $("#logEmail").parents("form:eq(0)").find("input[name='service']").val("docsplugin");

    }
}, false);
